Summary: Library for reading and writing quicktime files
Name: libquicktime
Version: 1.2.3
Release: 1
License: GPL
Group: System Environment/Libraries
URL: http://libquicktime.sourceforge.net/
Source0: http://dl.sf.net/libquicktime/%{name}-%{version}.tar.gz
Patch0: %{name}-%{version}-aix.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

BuildRequires: gcc >= 4.2.3-2
BuildRequires: gettext

BuildRequires: faac-devel >= 1.28
BuildRequires: faad2-devel >= 2.7
BuildRequires: gtk2-devel >= 2.8.3
BuildRequires: lame-devel >= 3.98.4
BuildRequires: libjpeg-devel >= 6b
BuildRequires: libpng-devel >= 1.2.44
BuildRequires: libvorbis-devel >= 1.2.3
BuildRequires: zlib-devel

Requires: libgcc >= 4.2.3-2
Requires: gettext

Requires: faac >= 1.28
Requires: faad2 >= 2.7
Requires: gtk2 >= 2.8.3
Requires: lame >= 3.98.4
Requires: libjpeg >= 6b
Requires: libpng >= 1.2.44
Requires: libvorbis >= 1.2.3
Requires: zlib

%define _libdir64 %{_prefix}/lib64

%description
Libquicktime is a library for reading and writing QuickTime files
on UNIX systems. Video CODECs supported by this library are OpenDivX, MJPA,
JPEG Photo, PNG, RGB, YUV 4:2:2, and YUV 4:2:0 compression.  Supported
audio CODECs are Ogg Vorbis, IMA4, ulaw, and any linear PCM format.

Libquicktime is based on the quicktime4linux library.  Libquicktime add
features such as a GNU build tools-based build process and dynamically
loadable CODECs.

The library is available as 32-bit and 64-bit.


%package devel
Summary: Development files from the libquicktime library
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: faac-devel >= 1.28
Requires: faad2-devel >= 2.7
Requires: gtk2-devel >= 2.8.3
Requires: lame-devel >= 3.98.4
Requires: libjpeg-devel >= 6b
Requires: libpng-devel >= 1.2.44
Requires: libvorbis-devel >= 1.2.3
Requires: zlib-devel
Requires: pkg-config

%description devel
libquicktime is a library for reading and writing quicktime files. It
is based on the quicktime4linux library, with many extensions.

You will need to install this development package if you intend to rebuild
programs that need to access quicktime files using libquicktime.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "gcc -maix64".


%prep
%setup -q
%patch0
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cp -r 32bit/* 64bit/


%build
export CFLAGS="-DSYSV -D_AIX -D_AIX32 -D_AIX41 -D_AIX43 -D_AIX51 -D_ALL_SOURCE -DFUNCPROTO=15 -O -I/opt/freeware/include"

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export CC="gcc -maix64 -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGE_FILES"
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --mandir=%{_mandir} \
    --enable-gpl \
    --enable-shared --disable-static \
    --enable-largefile \
    --with-x \
    --without-alsa \
    --without-visibility
make %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
export CC="gcc -maix32 -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGE_FILES"
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-gpl \
    --enable-shared --disable-static \
    --enable-largefile \
    --with-x \
    --without-alsa \
    --without-visibility
make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
gmake DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../32bit
export OBJECT_MODE=32
gmake DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/%{name}.a ${RPM_BUILD_ROOT}%{_libdir64}/%{name}.so*

# add compatibility symlink for "quicktime/lqt.h" includes
# (for transcode 1.0.0beta3)
%{__ln_s} lqt ${RPM_BUILD_ROOT}%{_includedir}/quicktime

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)

cd ${RPM_BUILD_ROOT}%{_libdir}/%{name}
for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
done

cd ${RPM_BUILD_ROOT}%{_libdir64}/%{name}
for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
done


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc 32bit/COPYING 32bit/README 32bit/TODO
%{_bindir}/lqt*
%{_bindir}/qt*
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
%dir %{_libdir}/%{name}/
%dir %{_libdir64}/%{name}/
%{_libdir}/%{name}/lqt_*.a
%{_libdir64}/%{name}/lqt_*.a
%{_libdir}/%{name}/lqt_*.so
%{_libdir64}/%{name}/lqt_*.so
%{_datadir}/locale/*/*/*
/usr/bin/lqt*
/usr/bin/qt*
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files devel
%defattr(-,root,system,-)
%doc 32bit/doc/*.html 32bit/doc/*.html 32bit/doc/apiref/
%{_bindir}/libquicktime_config
%{_includedir}/*
%{_libdir}/*.la
%{_libdir64}/*.la
%{_libdir}/%{name}/lqt_*.la
%{_libdir64}/%{name}/lqt_*.la
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir64}/pkgconfig/%{name}.pc
/usr/bin/libquicktime_config
/usr/include/*
/usr/lib/*.la
/usr/lib64/*.la


%changelog
* Wed Jul 06 2011 Michael Perzl <michael@perzl.org> - 1.2.3-1
- updated to version 1.2.3

* Mon Jan 10 2011 Michael Perzl <michael@perzl.org> - 1.2.2-1
- updated to version 1.2.2

* Tue Dec 07 2010 Michael Perzl <michael@perzl.org> - 1.2.1-1
- updated to version 1.2.1

* Tue Dec 07 2010 Michael Perzl <michael@perzl.org> - 1.1.5-1
- first version for AIX V5.1 and higher
